<template>
	<xn-form-container
		:title="formData.id ? '编辑优惠券记录' : '增加优惠券记录'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="优惠券编码：" name="couponNo">
				<a-input v-model:value="formData.couponNo" placeholder="请输入优惠券编码" allow-clear />
			</a-form-item>
			<a-form-item label="优惠券生成时间：" name="time">
				<a-date-picker v-model:value="formData.time" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择优惠券生成时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="充值方案id：" name="rechargePlanId">
				<a-input v-model:value="formData.rechargePlanId" placeholder="请输入充值方案id" allow-clear />
			</a-form-item>
			<a-form-item label="充值记录表id：" name="rechargeRecordId">
				<a-input v-model:value="formData.rechargeRecordId" placeholder="请输入充值记录表id" allow-clear />
			</a-form-item>
			<a-form-item label="是否核销： 0.否 1.是：" name="couponStatus">
				<a-input v-model:value="formData.couponStatus" placeholder="请输入是否核销： 0.否 1.是" allow-clear />
			</a-form-item>
			<a-form-item label="有效期开始时间：" name="startTime">
				<a-date-picker v-model:value="formData.startTime" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择有效期开始时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="有效期截止时间：" name="endTime">
				<a-date-picker v-model:value="formData.endTime" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择有效期截止时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="核销人：" name="destroyUser">
				<a-input v-model:value="formData.destroyUser" placeholder="请输入核销人" allow-clear />
			</a-form-item>
			<a-form-item label="核销时间：" name="destroyTime">
				<a-date-picker v-model:value="formData.destroyTime" value-format="YYYY-MM-DD HH:mm:ss" show-time placeholder="请选择核销时间" style="width: 100%" />
			</a-form-item>
			<a-form-item label="核销门店：" name="orgId">
				<a-input v-model:value="formData.orgId" placeholder="请输入核销门店" allow-clear />
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizCouponRecordForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizCouponRecordApi from '@/api/biz/bizCouponRecordApi'
	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizCouponRecordApi
					.bizCouponRecordSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
